﻿##################

def dessinerTableau(tab):
    for j in range(0,len(tab)):
        for i in range(0,len(tab)):
            if (tab[i][j]==1):
                print('X', end=' ')
            else:
                print('.', end=' ')
        print()



###################

def getLabyrinthe():
    n=8

    # labyrinthe vide
    laby = []
    for i in range(0,n):
        ligne=[]
        for j in range(0,n):
            ligne+=[0]
        laby+=[ligne]

    # arene
    for i in range(0,n):
        laby[i][0]=1
        laby[i][n-1]=1
        laby[0][i]=1
        laby[n-1][i]=1

    # construction de cases
    laby[3][1]=1
    laby[3][2]=1
    laby[5][2]=1
    laby[2][3]=1
    laby[3][3]=1
    laby[4][3]=1
    laby[5][3]=1
    laby[1][5]=1
    laby[3][5]=1
    laby[4][5]=1
    laby[6][5]=1

    return laby
####################

def chercheChemin(laby,x,y):
    """
    cherche un chemin de base a partir de x,y
    A chaque iteration, parcourt tout le tableau
    """
    #print("####################################")
    #print("####################################")
    #print("########### parcours complet ######")
    #print("####################################")
    #print("####################################")

    # construit copie laby
    chemin=[]
    for i in range(0,len(laby)):
        ligne=[]
        for j in range(0,len(laby[i])):
            ligne+=[1000]
        chemin+=[ligne]

    # case en x et y est nulle
    chemin[x][y]=0
    indice=0

    #parcours le tableau tant qu'il y a des changements
    fin=False
    while not(fin) :
        # par defaut on s'arrete au prochain coup
        fin=True
        # on met a jour les cases
        for i in range(0,len(laby)):
            for j in range(0,len(laby[i])):
                # si la case est au bon indice
                if chemin[i][j]==indice:
                    # ajoute indice +1 cases voisines si pas un mur
                    changeindice(chemin,i+1,j,indice, laby)
                    changeindice(chemin,i-1,j,indice, laby)
                    changeindice(chemin,i,j+1,indice, laby)
                    changeindice(chemin,i,j-1,indice, laby)
                    # changement donc non fini
                    fin=False
        # on augmente l'indice de la case cherchee
        indice=indice+1

        # affiche le chemin
        #print("##############################")
        #dessinerChemin(chemin)
        #print("##############################")

    return chemin

def changeindice(chemin,i,j,indice, laby):
    # si c'est un pas un mur
    if laby[i][j]!=1:
        # si la case est plus grande que indice+1
        if chemin[i][j]>indice+1:
            # on met la case a indice +1
            chemin[i][j]=indice+1

###################

def chercheCheminIntelligent(laby,x,y):
    """
	cherche un chemin de base a partir de x,y
	A chaque iteration, prend premier liste ouvert(pile)
	"""

    # construit copie laby
    chemin = []
    for i in range(0,len(laby)):
        ligne=[]
        for j in range(0,len(laby[i])):
            ligne+=[1000]
        chemin+=[ligne]

    #parcours le tableau tant qu'il y a des changements
    ouvert=[[x,y]]
    chemin[x][y]=0
    while len(ouvert) !=0 :
        # par defaut on s'arrete au prochain coup
        fin=True

        # on met a jour les cases dans ouvert
        case=ouvert[0]
        i=case[0]
        j=case[1]
        # print(i,",",j)
        # on supprime la case
        del ouvert[0]

        # prend indice de la case
        indice=chemin[i][j]

        # ajoute indice +1 cases voisines si pas un mur
        changeindiceInt(chemin,i+1,j,indice, laby,ouvert)
        changeindiceInt(chemin,i-1,j,indice, laby,ouvert)
        changeindiceInt(chemin,i,j+1,indice, laby,ouvert)
        changeindiceInt(chemin,i,j-1,indice, laby,ouvert)

        # affiche le chemin
        #print("##############################")
        #dessinerChemin(chemin)
        #print("##############################")

    return chemin

###################

def chercheCheminDijkstra(laby,x,y):
    """
    cherche un chemin de base a partir de x,y
    A chaque iteration, prend plus petit (dijkstra)
    """

    # construit copie laby
    chemin=[]
    for i in range(0,len(laby)):
        ligne=[]
        for j in range(0,len(laby[i])):
            ligne+=[1000]
        chemin+=[ligne]

    #parcours le tableau tant qu'il y a des changements
    ouvert=[[x,y,0]]
    chemin[x][y]=0
    while len(ouvert) !=0 :
        # par defaut on s'arrete au prochain coup
        fin=True

        # on prend le plus petit dans ouvert
        min=1000
        ind=-1
        for num in range(0,len(ouvert)):
            # si c'est le min
            if ouvert[num][2]<min:
                min=ouvert[num][2]
                ind=num

        case=ouvert[ind]
        i=case[0]
        j=case[1]
        # on supprime la case
        del ouvert[ind]

        # prend indice de la case
        indice=case[2]

        # ajoute indice +1 cases voisines si pas un mur
        changeindiceInt(chemin,i+1,j,indice, laby,ouvert)
        changeindiceInt(chemin,i-1,j,indice, laby,ouvert)
        changeindiceInt(chemin,i,j+1,indice, laby,ouvert)
        changeindiceInt(chemin,i,j-1,indice, laby,ouvert)

        # affiche le chemin
        #print("##############################")
        #dessinerChemin(chemin)
        #print("##############################")

    return chemin

def changeindiceInt(chemin,i,j,indice, laby,ouvert):
    # si c'est un pas un mur
    if laby[i][j]!=1:
        # si la case est plus grande que indice+1
        if chemin[i][j]>indice+1:
            # on met la case a indice +1
            chemin[i][j]=indice+1
            # on la stocke dans les cases a explorer
            ouvert+=[[i,j,indice+1]]


####################

def dessinerChemin(tab):
    # dessine les lignes
    for j in range(0,len(tab)):

        # pour chaque colonnee
        for i in range(0,len(tab)):
            # recupere la valeur calculee
            val=tab[i][j]

            # si c'est 1000, c'est une case non visitee
            if val==1000:
                print("   ",end=' ')
            else:
                print(val,end=' ')
                if val<0:
                        val=-val*10
                if val==0:
                    val=1
                while (val<100):
                    val=val*10
                    print(' ',end='')
        print()

###################

import time


laby=getLabyrinthe()
dessinerTableau(laby)

# recherche normale

tmps1=time.clock()
chemin=chercheChemin(laby,4,6)
tmps2=time.clock()

dessinerChemin(chemin)
print (tmps2-tmps1)
print ("***")


# recherche parcours malin

tmps1=time.clock()
chemin=chercheCheminIntelligent(laby,4,6)
tmps2=time.clock()

dessinerChemin(chemin)
print (tmps2-tmps1)
print ("***")

# recherche dijkstra

tmps1=time.clock()
chemin=chercheCheminDijkstra(laby,4,6)
tmps2=time.clock()

dessinerChemin(chemin)
print (tmps2-tmps1)
print ("***")
